Index: /trunk/src/VBox/VMM/VMM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMM.cpp	(revision 34321)
+++ /trunk/src/VBox/VMM/VMM.cpp	(revision 34322)
@@ -121,5 +121,5 @@
  * @param   pVM         The VM to operate on.
  */
-VMMR3DECL(int) VMMR3Init(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3Init(PVM pVM)
 {
     LogFlow(("VMMR3Init\n"));
@@ -465,5 +465,5 @@
  * @param   pVM         The VM to operate on.
  */
-VMMR3DECL(int) VMMR3InitR0(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3InitR0(PVM pVM)
 {
     int    rc;
@@ -527,5 +527,5 @@
  * @param   pVM         The VM to operate on.
  */
-VMMR3DECL(int) VMMR3InitRC(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3InitRC(PVM pVM)
 {
     PVMCPU pVCpu = VMMGetCpu(pVM);
@@ -689,5 +689,5 @@
  * @param   pVM         The VM handle.
  */
-VMMR3DECL(int) VMMR3Term(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3Term(PVM pVM)
 {
     PVMCPU pVCpu = VMMGetCpu(pVM);
@@ -771,5 +771,5 @@
  * @param   pVM         The VM to operate on.
  */
-VMMR3DECL(int) VMMR3TermCPU(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3TermCPU(PVM pVM)
 {
     return VINF_SUCCESS;
@@ -787,5 +787,5 @@
  * @param   offDelta    The relocation delta.
  */
-VMMR3DECL(void) VMMR3Relocate(PVM pVM, RTGCINTPTR offDelta)
+VMMR3_INT_DECL(void) VMMR3Relocate(PVM pVM, RTGCINTPTR offDelta)
 {
     LogFlow(("VMMR3Relocate: offDelta=%RGv\n", offDelta));
@@ -838,5 +838,5 @@
  * @param   pVM     The VM handle.
  */
-VMMR3DECL(int)  VMMR3UpdateLoggers(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3UpdateLoggers(PVM pVM)
 {
     /*
@@ -1075,5 +1075,5 @@
  * @remark  This has to work before VMMR3Relocate() is called.
  */
-VMMR3DECL(int) VMMR3GetImportRC(PVM pVM, const char *pszSymbol, PRTRCPTR pRCPtrValue)
+VMMR3_INT_DECL(int) VMMR3GetImportRC(PVM pVM, const char *pszSymbol, PRTRCPTR pRCPtrValue)
 {
     if (!strcmp(pszSymbol, "g_Logger"))
@@ -1104,5 +1104,5 @@
  * @param   pVM             The VM handle.
  */
-VMMR3DECL(void) VMMR3YieldSuspend(PVM pVM)
+VMMR3_INT_DECL(void) VMMR3YieldSuspend(PVM pVM)
 {
     VMCPU_ASSERT_EMT(&pVM->aCpus[0]);
@@ -1126,5 +1126,5 @@
  * @param   pVM             The VM handle.
  */
-VMMR3DECL(void) VMMR3YieldStop(PVM pVM)
+VMMR3_INT_DECL(void) VMMR3YieldStop(PVM pVM)
 {
     if (!pVM->vmm.s.cYieldResumeMillies)
@@ -1140,5 +1140,5 @@
  * @param   pVM             The VM handle.
  */
-VMMR3DECL(void) VMMR3YieldResume(PVM pVM)
+VMMR3_INT_DECL(void) VMMR3YieldResume(PVM pVM)
 {
     if (pVM->vmm.s.cYieldResumeMillies)
@@ -1196,5 +1196,5 @@
  * @param   pVCpu       The VMCPU to operate on.
  */
-VMMR3DECL(int) VMMR3RawRunGC(PVM pVM, PVMCPU pVCpu)
+VMMR3_INT_DECL(int) VMMR3RawRunGC(PVM pVM, PVMCPU pVCpu)
 {
     Log2(("VMMR3RawRunGC: (cs:eip=%04x:%08x)\n", CPUMGetGuestCS(pVCpu), CPUMGetGuestEIP(pVCpu)));
@@ -1265,5 +1265,5 @@
  * @param   pVCpu       The VMCPU to operate on.
  */
-VMMR3DECL(int) VMMR3HwAccRunGC(PVM pVM, PVMCPU pVCpu)
+VMMR3_INT_DECL(int) VMMR3HwAccRunGC(PVM pVM, PVMCPU pVCpu)
 {
     Log2(("VMMR3HwAccRunGC: (cs:eip=%04x:%08x)\n", CPUMGetGuestCS(pVCpu), CPUMGetGuestEIP(pVCpu)));
@@ -1362,5 +1362,5 @@
  * @param   uVector     SIPI vector
  */
-VMMR3DECL(void) VMMR3SendSipi(PVM pVM, VMCPUID idCpu,  uint32_t uVector)
+VMMR3_INT_DECL(void) VMMR3SendSipi(PVM pVM, VMCPUID idCpu,  uint32_t uVector)
 {
     AssertReturnVoid(idCpu < pVM->cCpus);
@@ -1376,5 +1376,5 @@
  * @param   idCpu       Virtual CPU to perform int IPI on
  */
-VMMR3DECL(void) VMMR3SendInitIpi(PVM pVM, VMCPUID idCpu)
+VMMR3_INT_DECL(void) VMMR3SendInitIpi(PVM pVM, VMCPUID idCpu)
 {
     AssertReturnVoid(idCpu < pVM->cCpus);
@@ -1441,5 +1441,6 @@
  * @param   pvUser      User specified parameter
  *
- * @thread EMT
+ * @thread  EMT
+ * @todo    Remove this if not used again soon.
  */
 VMMR3DECL(int) VMMR3AtomicExecuteHandler(PVM pVM, PFNATOMICHANDLER pfnHandler, void *pvUser)
@@ -1682,5 +1683,5 @@
  * @thread  EMT
  */
-VMMR3DECL(int) VMMR3EmtRendezvousFF(PVM pVM, PVMCPU pVCpu)
+VMMR3_INT_DECL(int) VMMR3EmtRendezvousFF(PVM pVM, PVMCPU pVCpu)
 {
     return vmmR3EmtRendezvousCommon(pVM, pVCpu, false /* fIsCaller */, pVM->vmm.s.fRendezvousFlags,
@@ -1834,5 +1835,5 @@
  * @param   cbRead          The number of bytes to read.
  */
-VMMR3DECL(int) VMMR3ReadR0Stack(PVM pVM, VMCPUID idCpu, RTHCUINTPTR R0Addr, void *pvBuf, size_t cbRead)
+VMMR3_INT_DECL(int) VMMR3ReadR0Stack(PVM pVM, VMCPUID idCpu, RTHCUINTPTR R0Addr, void *pvBuf, size_t cbRead)
 {
     PVMCPU pVCpu = VMMGetCpuById(pVM, idCpu);
Index: /trunk/src/VBox/VMM/VMMSwitcher.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMSwitcher.cpp	(revision 34321)
+++ /trunk/src/VBox/VMM/VMMSwitcher.cpp	(revision 34322)
@@ -938,5 +938,5 @@
  * @remark  This function may be called before the VMM is initialized.
  */
-VMMR3DECL(int) VMMR3SelectSwitcher(PVM pVM, VMMSWITCHER enmSwitcher)
+VMMR3_INT_DECL(int) VMMR3SelectSwitcher(PVM pVM, VMMSWITCHER enmSwitcher)
 {
     /*
@@ -985,5 +985,5 @@
  * @param   pVM             VM handle.
  */
-VMMR3DECL(int) VMMR3DisableSwitcher(PVM pVM)
+VMMR3_INT_DECL(int) VMMR3DisableSwitcher(PVM pVM)
 {
 /** @todo r=bird: I would suggest that we create a dummy switcher which just does something like:
@@ -1006,5 +1006,5 @@
  * @param   enmSwitcher     The new switcher.
  */
-VMMR3DECL(RTR0PTR) VMMR3GetHostToGuestSwitcher(PVM pVM, VMMSWITCHER enmSwitcher)
+VMMR3_INT_DECL(RTR0PTR) VMMR3GetHostToGuestSwitcher(PVM pVM, VMMSWITCHER enmSwitcher)
 {
     /*